class EventListener{constructor(e,t,r){this.eventTarget=e,this.eventName=t,this.eventOptions=r,this.unorderedBindings=new Set}connect(){this.eventTarget.addEventListener(this.eventName,this,this.eventOptions)}disconnect(){this.eventTarget.removeEventListener(this.eventName,this,this.eventOptions)}bindingConnected(e){this.unorderedBindings.add(e)}bindingDisconnected(e){this.unorderedBindings.delete(e)}handleEvent(e){var t=extendEvent(e);for(const r of this.bindings){if(t.immediatePropagationStopped)break;r.handleEvent(t)}}get bindings(){return Array.from(this.unorderedBindings).sort((e,t)=>{e=e.index,t=t.index;return e<t?-1:t<e?1:0})}}function extendEvent(e){if("immediatePropagationStopped"in e)return e;{const t=e["stopImmediatePropagation"];return Object.assign(e,{immediatePropagationStopped:!1,stopImmediatePropagation(){this.immediatePropagationStopped=!0,t.call(this)}})}}class Dispatcher{constructor(e){this.application=e,this.eventListenerMaps=new Map,this.started=!1}start(){this.started||(this.started=!0,this.eventListeners.forEach(e=>e.connect()))}stop(){this.started&&(this.started=!1,this.eventListeners.forEach(e=>e.disconnect()))}get eventListeners(){return Array.from(this.eventListenerMaps.values()).reduce((e,t)=>e.concat(Array.from(t.values())),[])}bindingConnected(e){this.fetchEventListenerForBinding(e).bindingConnected(e)}bindingDisconnected(e){this.fetchEventListenerForBinding(e).bindingDisconnected(e)}handleError(e,t,r={}){this.application.handleError(e,"Error "+t,r)}fetchEventListenerForBinding(e){var{eventTarget:e,eventName:t,eventOptions:r}=e;return this.fetchEventListener(e,t,r)}fetchEventListener(e,t,r){var s=this.fetchEventListenerMapForEventTarget(e),i=this.cacheKey(t,r);let n=s.get(i);return n||(n=this.createEventListener(e,t,r),s.set(i,n)),n}createEventListener(e,t,r){e=new EventListener(e,t,r);return this.started&&e.connect(),e}fetchEventListenerMapForEventTarget(e){let t=this.eventListenerMaps.get(e);return t||(t=new Map,this.eventListenerMaps.set(e,t)),t}cacheKey(e,t){const r=[e];return Object.keys(t).sort().forEach(e=>{r.push((t[e]?"":"!")+e)}),r.join(":")}}const descriptorPattern=/^((.+?)(@(window|document))?->)?(.+?)(#([^:]+?))(:(.+))?$/;function parseActionDescriptorString(e){e=e.trim().match(descriptorPattern)||[];return{eventTarget:parseEventTarget(e[4]),eventName:e[2],eventOptions:e[9]?parseEventOptions(e[9]):{},identifier:e[5],methodName:e[7]}}function parseEventTarget(e){return"window"==e?window:"document"==e?document:void 0}function parseEventOptions(e){return e.split(":").reduce((e,t)=>Object.assign(e,{[t.replace(/^!/,"")]:!/^!/.test(t)}),{})}function stringifyEventTarget(e){return e==window?"window":e==document?"document":void 0}function camelize(e){return e.replace(/(?:[_-])([a-z0-9])/g,(e,t)=>t.toUpperCase())}function capitalize(e){return e.charAt(0).toUpperCase()+e.slice(1)}function dasherize(e){return e.replace(/([A-Z])/g,(e,t)=>"-"+t.toLowerCase())}function tokenize(e){return e.match(/[^\s]+/g)||[]}class Action{constructor(e,t,r){this.element=e,this.index=t,this.eventTarget=r.eventTarget||e,this.eventName=r.eventName||getDefaultEventNameForElement(e)||error("missing event name"),this.eventOptions=r.eventOptions||{},this.identifier=r.identifier||error("missing identifier"),this.methodName=r.methodName||error("missing method name")}static forToken(e){return new this(e.element,e.index,parseActionDescriptorString(e.content))}toString(){var e=this.eventTargetName?"@"+this.eventTargetName:"";return this.eventName+e+`->${this.identifier}#`+this.methodName}get params(){return this.eventTarget instanceof Element?this.getParamsFromEventTargetAttributes(this.eventTarget):{}}getParamsFromEventTargetAttributes(e){const r={},s=new RegExp(`^data-${this.identifier}-(.+)-param$`);return Array.from(e.attributes).forEach(({name:e,value:t})=>{e=e.match(s),e=e&&e[1];e&&Object.assign(r,{[camelize(e)]:typecast(t)})}),r}get eventTargetName(){return stringifyEventTarget(this.eventTarget)}}const defaultEventNames={a:e=>"click",button:e=>"click",form:e=>"submit",details:e=>"toggle",input:e=>"submit"==e.getAttribute("type")?"click":"input",select:e=>"change",textarea:e=>"input"};function getDefaultEventNameForElement(e){var t=e.tagName.toLowerCase();if(t in defaultEventNames)return defaultEventNames[t](e)}function error(e){throw new Error(e)}function typecast(t){try{return JSON.parse(t)}catch(e){return t}}class Binding{constructor(e,t){this.context=e,this.action=t}get index(){return this.action.index}get eventTarget(){return this.action.eventTarget}get eventOptions(){return this.action.eventOptions}get identifier(){return this.context.identifier}handleEvent(e){this.willBeInvokedByEvent(e)&&this.invokeWithEvent(e)}get eventName(){return this.action.eventName}get method(){var e=this.controller[this.methodName];if("function"==typeof e)return e;throw new Error(`Action "${this.action}" references undefined method "${this.methodName}"`)}invokeWithEvent(t){var{target:r,currentTarget:s}=t;try{var i=this.action["params"],n=Object.assign(t,{params:i});this.method.call(this.controller,n),this.context.logDebugActivity(this.methodName,{event:t,target:r,currentTarget:s,action:this.methodName})}catch(e){var{identifier:i,controller:n,element:r,index:s}=this;this.context.handleError(e,`invoking action "${this.action}"`,{identifier:i,controller:n,element:r,index:s,event:t})}}willBeInvokedByEvent(e){e=e.target;return this.element===e||(e instanceof Element&&this.element.contains(e)?this.scope.containsElement(e):this.scope.containsElement(this.action.element))}get controller(){return this.context.controller}get methodName(){return this.action.methodName}get element(){return this.scope.element}get scope(){return this.context.scope}}class ElementObserver{constructor(e,t){this.mutationObserverInit={attributes:!0,childList:!0,subtree:!0},this.element=e,this.started=!1,this.delegate=t,this.elements=new Set,this.mutationObserver=new MutationObserver(e=>this.processMutations(e))}start(){this.started||(this.started=!0,this.mutationObserver.observe(this.element,this.mutationObserverInit),this.refresh())}pause(e){this.started&&(this.mutationObserver.disconnect(),this.started=!1),e(),this.started||(this.mutationObserver.observe(this.element,this.mutationObserverInit),this.started=!0)}stop(){this.started&&(this.mutationObserver.takeRecords(),this.mutationObserver.disconnect(),this.started=!1)}refresh(){if(this.started){var e=new Set(this.matchElementsInTree());for(const t of Array.from(this.elements))e.has(t)||this.removeElement(t);for(const r of Array.from(e))this.addElement(r)}}processMutations(e){if(this.started)for(const t of e)this.processMutation(t)}processMutation(e){"attributes"==e.type?this.processAttributeChange(e.target,e.attributeName):"childList"==e.type&&(this.processRemovedNodes(e.removedNodes),this.processAddedNodes(e.addedNodes))}processAttributeChange(e,t){this.elements.has(e)?this.delegate.elementAttributeChanged&&this.matchElement(e)?this.delegate.elementAttributeChanged(e,t):this.removeElement(e):this.matchElement(e)&&this.addElement(e)}processRemovedNodes(e){for(const r of Array.from(e)){var t=this.elementFromNode(r);t&&this.processTree(t,this.removeElement)}}processAddedNodes(e){for(const r of Array.from(e)){var t=this.elementFromNode(r);t&&this.elementIsActive(t)&&this.processTree(t,this.addElement)}}matchElement(e){return this.delegate.matchElement(e)}matchElementsInTree(e=this.element){return this.delegate.matchElementsInTree(e)}processTree(e,t){for(const r of this.matchElementsInTree(e))t.call(this,r)}elementFromNode(e){if(e.nodeType==Node.ELEMENT_NODE)return e}elementIsActive(e){return e.isConnected==this.element.isConnected&&this.element.contains(e)}addElement(e){this.elements.has(e)||this.elementIsActive(e)&&(this.elements.add(e),this.delegate.elementMatched)&&this.delegate.elementMatched(e)}removeElement(e){this.elements.has(e)&&(this.elements.delete(e),this.delegate.elementUnmatched)&&this.delegate.elementUnmatched(e)}}class AttributeObserver{constructor(e,t,r){this.attributeName=t,this.delegate=r,this.elementObserver=new ElementObserver(e,this)}get element(){return this.elementObserver.element}get selector(){return`[${this.attributeName}]`}start(){this.elementObserver.start()}pause(e){this.elementObserver.pause(e)}stop(){this.elementObserver.stop()}refresh(){this.elementObserver.refresh()}get started(){return this.elementObserver.started}matchElement(e){return e.hasAttribute(this.attributeName)}matchElementsInTree(e){var t=this.matchElement(e)?[e]:[],e=Array.from(e.querySelectorAll(this.selector));return t.concat(e)}elementMatched(e){this.delegate.elementMatchedAttribute&&this.delegate.elementMatchedAttribute(e,this.attributeName)}elementUnmatched(e){this.delegate.elementUnmatchedAttribute&&this.delegate.elementUnmatchedAttribute(e,this.attributeName)}elementAttributeChanged(e,t){this.delegate.elementAttributeValueChanged&&this.attributeName==t&&this.delegate.elementAttributeValueChanged(e,t)}}class StringMapObserver{constructor(e,t){this.element=e,this.delegate=t,this.started=!1,this.stringMap=new Map,this.mutationObserver=new MutationObserver(e=>this.processMutations(e))}start(){this.started||(this.started=!0,this.mutationObserver.observe(this.element,{attributes:!0,attributeOldValue:!0}),this.refresh())}stop(){this.started&&(this.mutationObserver.takeRecords(),this.mutationObserver.disconnect(),this.started=!1)}refresh(){if(this.started)for(const e of this.knownAttributeNames)this.refreshAttribute(e,null)}processMutations(e){if(this.started)for(const t of e)this.processMutation(t)}processMutation(e){var t=e.attributeName;t&&this.refreshAttribute(t,e.oldValue)}refreshAttribute(e,t){var r=this.delegate.getStringMapKeyForAttribute(e);if(null!=r){this.stringMap.has(e)||this.stringMapKeyAdded(r,e);var s=this.element.getAttribute(e);if(this.stringMap.get(e)!=s&&this.stringMapValueChanged(s,r,t),null==s){const t=this.stringMap.get(e);this.stringMap.delete(e),t&&this.stringMapKeyRemoved(r,e,t)}else this.stringMap.set(e,s)}}stringMapKeyAdded(e,t){this.delegate.stringMapKeyAdded&&this.delegate.stringMapKeyAdded(e,t)}stringMapValueChanged(e,t,r){this.delegate.stringMapValueChanged&&this.delegate.stringMapValueChanged(e,t,r)}stringMapKeyRemoved(e,t,r){this.delegate.stringMapKeyRemoved&&this.delegate.stringMapKeyRemoved(e,t,r)}get knownAttributeNames(){return Array.from(new Set(this.currentAttributeNames.concat(this.recordedAttributeNames)))}get currentAttributeNames(){return Array.from(this.element.attributes).map(e=>e.name)}get recordedAttributeNames(){return Array.from(this.stringMap.keys())}}function add(e,t,r){fetch(e,t).add(r)}function del(e,t,r){fetch(e,t).delete(r),prune(e,t)}function fetch(e,t){let r=e.get(t);return r||(r=new Set,e.set(t,r)),r}function prune(e,t){var r=e.get(t);null!=r&&0==r.size&&e.delete(t)}class Multimap{constructor(){this.valuesByKey=new Map}get keys(){return Array.from(this.valuesByKey.keys())}get values(){return Array.from(this.valuesByKey.values()).reduce((e,t)=>e.concat(Array.from(t)),[])}get size(){return Array.from(this.valuesByKey.values()).reduce((e,t)=>e+t.size,0)}add(e,t){add(this.valuesByKey,e,t)}delete(e,t){del(this.valuesByKey,e,t)}has(e,t){e=this.valuesByKey.get(e);return null!=e&&e.has(t)}hasKey(e){return this.valuesByKey.has(e)}hasValue(t){return Array.from(this.valuesByKey.values()).some(e=>e.has(t))}getValuesForKey(e){e=this.valuesByKey.get(e);return e?Array.from(e):[]}getKeysForValue(t){return Array.from(this.valuesByKey).filter(([,e])=>e.has(t)).map(([e])=>e)}}class IndexedMultimap extends Multimap{constructor(){super(),this.keysByValue=new Map}get values(){return Array.from(this.keysByValue.keys())}add(e,t){super.add(e,t),add(this.keysByValue,t,e)}delete(e,t){super.delete(e,t),del(this.keysByValue,t,e)}hasValue(e){return this.keysByValue.has(e)}getKeysForValue(e){e=this.keysByValue.get(e);return e?Array.from(e):[]}}class TokenListObserver{constructor(e,t,r){this.attributeObserver=new AttributeObserver(e,t,this),this.delegate=r,this.tokensByElement=new Multimap}get started(){return this.attributeObserver.started}start(){this.attributeObserver.start()}pause(e){this.attributeObserver.pause(e)}stop(){this.attributeObserver.stop()}refresh(){this.attributeObserver.refresh()}get element(){return this.attributeObserver.element}get attributeName(){return this.attributeObserver.attributeName}elementMatchedAttribute(e){this.tokensMatched(this.readTokensForElement(e))}elementAttributeValueChanged(e){var[e,t]=this.refreshTokensForElement(e);this.tokensUnmatched(e),this.tokensMatched(t)}elementUnmatchedAttribute(e){this.tokensUnmatched(this.tokensByElement.getValuesForKey(e))}tokensMatched(e){e.forEach(e=>this.tokenMatched(e))}tokensUnmatched(e){e.forEach(e=>this.tokenUnmatched(e))}tokenMatched(e){this.delegate.tokenMatched(e),this.tokensByElement.add(e.element,e)}tokenUnmatched(e){this.delegate.tokenUnmatched(e),this.tokensByElement.delete(e.element,e)}refreshTokensForElement(e){var t=this.tokensByElement.getValuesForKey(e),e=this.readTokensForElement(e),r=zip(t,e).findIndex(([e,t])=>!tokensAreEqual(e,t));return-1==r?[[],[]]:[t.slice(r),e.slice(r)]}readTokensForElement(e){var t=this.attributeName;return parseTokenString(e.getAttribute(t)||"",e,t)}}function parseTokenString(e,r,s){return e.trim().split(/\s+/).filter(e=>e.length).map((e,t)=>({element:r,attributeName:s,content:e,index:t}))}function zip(r,s){var e=Math.max(r.length,s.length);return Array.from({length:e},(e,t)=>[r[t],s[t]])}function tokensAreEqual(e,t){return e&&t&&e.index==t.index&&e.content==t.content}class ValueListObserver{constructor(e,t,r){this.tokenListObserver=new TokenListObserver(e,t,this),this.delegate=r,this.parseResultsByToken=new WeakMap,this.valuesByTokenByElement=new WeakMap}get started(){return this.tokenListObserver.started}start(){this.tokenListObserver.start()}stop(){this.tokenListObserver.stop()}refresh(){this.tokenListObserver.refresh()}get element(){return this.tokenListObserver.element}get attributeName(){return this.tokenListObserver.attributeName}tokenMatched(e){var t=e["element"],r=this.fetchParseResultForToken(e)["value"];r&&(this.fetchValuesByTokenForElement(t).set(e,r),this.delegate.elementMatchedValue(t,r))}tokenUnmatched(e){var t=e["element"],r=this.fetchParseResultForToken(e)["value"];r&&(this.fetchValuesByTokenForElement(t).delete(e),this.delegate.elementUnmatchedValue(t,r))}fetchParseResultForToken(e){let t=this.parseResultsByToken.get(e);return t||(t=this.parseToken(e),this.parseResultsByToken.set(e,t)),t}fetchValuesByTokenForElement(e){let t=this.valuesByTokenByElement.get(e);return t||(t=new Map,this.valuesByTokenByElement.set(e,t)),t}parseToken(e){try{return{value:this.delegate.parseValueForToken(e)}}catch(e){return{error:e}}}}class BindingObserver{constructor(e,t){this.context=e,this.delegate=t,this.bindingsByAction=new Map}start(){this.valueListObserver||(this.valueListObserver=new ValueListObserver(this.element,this.actionAttribute,this),this.valueListObserver.start())}stop(){this.valueListObserver&&(this.valueListObserver.stop(),delete this.valueListObserver,this.disconnectAllActions())}get element(){return this.context.element}get identifier(){return this.context.identifier}get actionAttribute(){return this.schema.actionAttribute}get schema(){return this.context.schema}get bindings(){return Array.from(this.bindingsByAction.values())}connectAction(e){var t=new Binding(this.context,e);this.bindingsByAction.set(e,t),this.delegate.bindingConnected(t)}disconnectAction(e){var t=this.bindingsByAction.get(e);t&&(this.bindingsByAction.delete(e),this.delegate.bindingDisconnected(t))}disconnectAllActions(){this.bindings.forEach(e=>this.delegate.bindingDisconnected(e)),this.bindingsByAction.clear()}parseValueForToken(e){e=Action.forToken(e);if(e.identifier==this.identifier)return e}elementMatchedValue(e,t){this.connectAction(t)}elementUnmatchedValue(e,t){this.disconnectAction(t)}}class ValueObserver{constructor(e,t){this.context=e,this.receiver=t,this.stringMapObserver=new StringMapObserver(this.element,this),this.valueDescriptorMap=this.controller.valueDescriptorMap,this.invokeChangedCallbacksForDefaultValues()}start(){this.stringMapObserver.start()}stop(){this.stringMapObserver.stop()}get element(){return this.context.element}get controller(){return this.context.controller}getStringMapKeyForAttribute(e){if(e in this.valueDescriptorMap)return this.valueDescriptorMap[e].name}stringMapKeyAdded(e,t){t=this.valueDescriptorMap[t];this.hasValue(e)||this.invokeChangedCallback(e,t.writer(this.receiver[e]),t.writer(t.defaultValue))}stringMapValueChanged(e,t,r){var s=this.valueDescriptorNameMap[t];null!==e&&(null===r&&(r=s.writer(s.defaultValue)),this.invokeChangedCallback(t,e,r))}stringMapKeyRemoved(e,t,r){var s=this.valueDescriptorNameMap[e];this.hasValue(e)?this.invokeChangedCallback(e,s.writer(this.receiver[e]),r):this.invokeChangedCallback(e,s.writer(s.defaultValue),r)}invokeChangedCallbacksForDefaultValues(){for(var{key:e,name:t,defaultValue:r,writer:s}of this.valueDescriptors)null==r||this.controller.data.has(e)||this.invokeChangedCallback(t,s(r),void 0)}invokeChangedCallback(t,r,s){var i=this.receiver[t+"Changed"];if("function"==typeof i){t=this.valueDescriptorNameMap[t],r=t.reader(r);let e=s;s&&(e=t.reader(s)),i.call(this.receiver,r,e)}}get valueDescriptors(){const t=this["valueDescriptorMap"];return Object.keys(t).map(e=>t[e])}get valueDescriptorNameMap(){const t={};return Object.keys(this.valueDescriptorMap).forEach(e=>{e=this.valueDescriptorMap[e];t[e.name]=e}),t}hasValue(e){e="has"+capitalize(this.valueDescriptorNameMap[e].name);return this.receiver[e]}}class TargetObserver{constructor(e,t){this.context=e,this.delegate=t,this.targetsByName=new Multimap}start(){this.tokenListObserver||(this.tokenListObserver=new TokenListObserver(this.element,this.attributeName,this),this.tokenListObserver.start())}stop(){this.tokenListObserver&&(this.disconnectAllTargets(),this.tokenListObserver.stop(),delete this.tokenListObserver)}tokenMatched({element:e,content:t}){this.scope.containsElement(e)&&this.connectTarget(e,t)}tokenUnmatched({element:e,content:t}){this.disconnectTarget(e,t)}connectTarget(e,t){var r;this.targetsByName.has(t,e)||(this.targetsByName.add(t,e),null!=(r=this.tokenListObserver)&&r.pause(()=>this.delegate.targetConnected(e,t)))}disconnectTarget(e,t){var r;this.targetsByName.has(t,e)&&(this.targetsByName.delete(t,e),null!=(r=this.tokenListObserver))&&r.pause(()=>this.delegate.targetDisconnected(e,t))}disconnectAllTargets(){for(const e of this.targetsByName.keys)for(const t of this.targetsByName.getValuesForKey(e))this.disconnectTarget(t,e)}get attributeName(){return`data-${this.context.identifier}-target`}get element(){return this.context.element}get scope(){return this.context.scope}}class Context{constructor(e,t){this.logDebugActivity=(e,t={})=>{var{identifier:r,controller:s,element:i}=this;t=Object.assign({identifier:r,controller:s,element:i},t),this.application.logDebugActivity(this.identifier,e,t)},this.module=e,this.scope=t,this.controller=new e.controllerConstructor(this),this.bindingObserver=new BindingObserver(this,this.dispatcher),this.valueObserver=new ValueObserver(this,this.controller),this.targetObserver=new TargetObserver(this,this);try{this.controller.initialize(),this.logDebugActivity("initialize")}catch(e){this.handleError(e,"initializing controller")}}connect(){this.bindingObserver.start(),this.valueObserver.start(),this.targetObserver.start();try{this.controller.connect(),this.logDebugActivity("connect")}catch(e){this.handleError(e,"connecting controller")}}disconnect(){try{this.controller.disconnect(),this.logDebugActivity("disconnect")}catch(e){this.handleError(e,"disconnecting controller")}this.targetObserver.stop(),this.valueObserver.stop(),this.bindingObserver.stop()}get application(){return this.module.application}get identifier(){return this.module.identifier}get schema(){return this.application.schema}get dispatcher(){return this.application.dispatcher}get element(){return this.scope.element}get parentElement(){return this.element.parentElement}handleError(e,t,r={}){var{identifier:s,controller:i,element:n}=this;r=Object.assign({identifier:s,controller:i,element:n},r),this.application.handleError(e,"Error "+t,r)}targetConnected(e,t){this.invokeControllerMethod(t+"TargetConnected",e)}targetDisconnected(e,t){this.invokeControllerMethod(t+"TargetDisconnected",e)}invokeControllerMethod(e,...t){var r=this.controller;"function"==typeof r[e]&&r[e](...t)}}function readInheritableStaticArrayValues(e,r){e=getAncestorsForConstructor(e);return Array.from(e.reduce((t,e)=>(getOwnStaticArrayValues(e,r).forEach(e=>t.add(e)),t),new Set))}function readInheritableStaticObjectPairs(e,r){return getAncestorsForConstructor(e).reduce((e,t)=>(e.push(...getOwnStaticObjectPairs(t,r)),e),[])}function getAncestorsForConstructor(e){for(var t=[];e;)t.push(e),e=Object.getPrototypeOf(e);return t.reverse()}function getOwnStaticArrayValues(e,t){e=e[t];return Array.isArray(e)?e:[]}function getOwnStaticObjectPairs(e,t){const r=e[t];return r?Object.keys(r).map(e=>[e,r[e]]):[]}function bless(e){return shadow(e,getBlessedProperties(e))}function shadow(e,t){var r=extend(e),e=getShadowProperties(e.prototype,t);return Object.defineProperties(r.prototype,e),r}function getBlessedProperties(n){return readInheritableStaticArrayValues(n,"blessings").reduce((e,t)=>{var r=t(n);for(const i in r){var s=e[i]||{};e[i]=Object.assign(s,r[i])}return e},{})}function getShadowProperties(s,i){return getOwnKeys(i).reduce((e,t)=>{var r=getShadowedDescriptor(s,i,t);return r&&Object.assign(e,{[t]:r}),e},{})}function getShadowedDescriptor(e,t,r){e=Object.getOwnPropertyDescriptor(e,r);if(!(e&&"value"in e))return t=Object.getOwnPropertyDescriptor(t,r).value,e&&(t.get=e.get||t.get,t.set=e.set||t.set),t}const getOwnKeys="function"==typeof Object.getOwnPropertySymbols?e=>[...Object.getOwnPropertyNames(e),...Object.getOwnPropertySymbols(e)]:Object.getOwnPropertyNames,extend=(()=>{function e(e){function t(){return Reflect.construct(e,arguments,new.target)}return t.prototype=Object.create(e.prototype,{constructor:{value:t}}),Reflect.setPrototypeOf(t,e),t}try{return(t=e(function(){this.a.call(this)})).prototype.a=function(){},new t,e}catch(e){return e=>class extends e{}}var t})();function blessDefinition(e){return{identifier:e.identifier,controllerConstructor:bless(e.controllerConstructor)}}class Module{constructor(e,t){this.application=e,this.definition=blessDefinition(t),this.contextsByScope=new WeakMap,this.connectedContexts=new Set}get identifier(){return this.definition.identifier}get controllerConstructor(){return this.definition.controllerConstructor}get contexts(){return Array.from(this.connectedContexts)}connectContextForScope(e){e=this.fetchContextForScope(e);this.connectedContexts.add(e),e.connect()}disconnectContextForScope(e){e=this.contextsByScope.get(e);e&&(this.connectedContexts.delete(e),e.disconnect())}fetchContextForScope(e){let t=this.contextsByScope.get(e);return t||(t=new Context(this,e),this.contextsByScope.set(e,t)),t}}class ClassMap{constructor(e){this.scope=e}has(e){return this.data.has(this.getDataKey(e))}get(e){return this.getAll(e)[0]}getAll(e){return tokenize(this.data.get(this.getDataKey(e))||"")}getAttributeName(e){return this.data.getAttributeNameForKey(this.getDataKey(e))}getDataKey(e){return e+"-class"}get data(){return this.scope.data}}class DataMap{constructor(e){this.scope=e}get element(){return this.scope.element}get identifier(){return this.scope.identifier}get(e){e=this.getAttributeNameForKey(e);return this.element.getAttribute(e)}set(e,t){var r=this.getAttributeNameForKey(e);return this.element.setAttribute(r,t),this.get(e)}has(e){e=this.getAttributeNameForKey(e);return this.element.hasAttribute(e)}delete(e){return!!this.has(e)&&(e=this.getAttributeNameForKey(e),this.element.removeAttribute(e),!0)}getAttributeNameForKey(e){return`data-${this.identifier}-`+dasherize(e)}}class Guide{constructor(e){this.warnedKeysByObject=new WeakMap,this.logger=e}warn(e,t,r){let s=this.warnedKeysByObject.get(e);s||(s=new Set,this.warnedKeysByObject.set(e,s)),s.has(t)||(s.add(t),this.logger.warn(r,e))}}function attributeValueContainsToken(e,t){return`[${e}~="${t}"]`}class TargetSet{constructor(e){this.scope=e}get element(){return this.scope.element}get identifier(){return this.scope.identifier}get schema(){return this.scope.schema}has(e){return null!=this.find(e)}find(...e){return e.reduce((e,t)=>e||this.findTarget(t)||this.findLegacyTarget(t),void 0)}findAll(...e){return e.reduce((e,t)=>[...e,...this.findAllTargets(t),...this.findAllLegacyTargets(t)],[])}findTarget(e){e=this.getSelectorForTargetName(e);return this.scope.findElement(e)}findAllTargets(e){e=this.getSelectorForTargetName(e);return this.scope.findAllElements(e)}getSelectorForTargetName(e){return attributeValueContainsToken(this.schema.targetAttributeForScope(this.identifier),e)}findLegacyTarget(e){var t=this.getLegacySelectorForTargetName(e);return this.deprecate(this.scope.findElement(t),e)}findAllLegacyTargets(t){var e=this.getLegacySelectorForTargetName(t);return this.scope.findAllElements(e).map(e=>this.deprecate(e,t))}getLegacySelectorForTargetName(e){e=this.identifier+"."+e;return attributeValueContainsToken(this.schema.targetAttribute,e)}deprecate(e,t){var r,s,i;return e&&(r=this["identifier"],s=this.schema.targetAttribute,i=this.schema.targetAttributeForScope(r),this.guide.warn(e,"target:"+t,`Please replace ${s}="${r}.${t}" with ${i}="${t}". `+`The ${s} attribute is deprecated and will be removed in a future version of Stimulus.`)),e}get guide(){return this.scope.guide}}class Scope{constructor(e,t,r,s){this.targets=new TargetSet(this),this.classes=new ClassMap(this),this.data=new DataMap(this),this.containsElement=e=>e.closest(this.controllerSelector)===this.element,this.schema=e,this.element=t,this.identifier=r,this.guide=new Guide(s)}findElement(e){return this.element.matches(e)?this.element:this.queryElements(e).find(this.containsElement)}findAllElements(e){return[...this.element.matches(e)?[this.element]:[],...this.queryElements(e).filter(this.containsElement)]}queryElements(e){return Array.from(this.element.querySelectorAll(e))}get controllerSelector(){return attributeValueContainsToken(this.schema.controllerAttribute,this.identifier)}}class ScopeObserver{constructor(e,t,r){this.element=e,this.schema=t,this.delegate=r,this.valueListObserver=new ValueListObserver(this.element,this.controllerAttribute,this),this.scopesByIdentifierByElement=new WeakMap,this.scopeReferenceCounts=new WeakMap}start(){this.valueListObserver.start()}stop(){this.valueListObserver.stop()}get controllerAttribute(){return this.schema.controllerAttribute}parseValueForToken(e){var{element:e,content:t}=e,r=this.fetchScopesByIdentifierForElement(e);let s=r.get(t);return s||(s=this.delegate.createScopeForElementAndIdentifier(e,t),r.set(t,s)),s}elementMatchedValue(e,t){var r=(this.scopeReferenceCounts.get(t)||0)+1;this.scopeReferenceCounts.set(t,r),1==r&&this.delegate.scopeConnected(t)}elementUnmatchedValue(e,t){var r=this.scopeReferenceCounts.get(t);r&&(this.scopeReferenceCounts.set(t,r-1),1==r)&&this.delegate.scopeDisconnected(t)}fetchScopesByIdentifierForElement(e){let t=this.scopesByIdentifierByElement.get(e);return t||(t=new Map,this.scopesByIdentifierByElement.set(e,t)),t}}class Router{constructor(e){this.application=e,this.scopeObserver=new ScopeObserver(this.element,this.schema,this),this.scopesByIdentifier=new Multimap,this.modulesByIdentifier=new Map}get element(){return this.application.element}get schema(){return this.application.schema}get logger(){return this.application.logger}get controllerAttribute(){return this.schema.controllerAttribute}get modules(){return Array.from(this.modulesByIdentifier.values())}get contexts(){return this.modules.reduce((e,t)=>e.concat(t.contexts),[])}start(){this.scopeObserver.start()}stop(){this.scopeObserver.stop()}loadDefinition(e){this.unloadIdentifier(e.identifier);e=new Module(this.application,e);this.connectModule(e)}unloadIdentifier(e){e=this.modulesByIdentifier.get(e);e&&this.disconnectModule(e)}getContextForElementAndIdentifier(t,e){e=this.modulesByIdentifier.get(e);if(e)return e.contexts.find(e=>e.element==t)}handleError(e,t,r){this.application.handleError(e,t,r)}createScopeForElementAndIdentifier(e,t){return new Scope(this.schema,e,t,this.logger)}scopeConnected(e){this.scopesByIdentifier.add(e.identifier,e);var t=this.modulesByIdentifier.get(e.identifier);t&&t.connectContextForScope(e)}scopeDisconnected(e){this.scopesByIdentifier.delete(e.identifier,e);var t=this.modulesByIdentifier.get(e.identifier);t&&t.disconnectContextForScope(e)}connectModule(t){this.modulesByIdentifier.set(t.identifier,t),this.scopesByIdentifier.getValuesForKey(t.identifier).forEach(e=>t.connectContextForScope(e))}disconnectModule(t){this.modulesByIdentifier.delete(t.identifier),this.scopesByIdentifier.getValuesForKey(t.identifier).forEach(e=>t.disconnectContextForScope(e))}}const defaultSchema={controllerAttribute:"data-controller",actionAttribute:"data-action",targetAttribute:"data-target",targetAttributeForScope:e=>`data-${e}-target`};class Application{constructor(e=document.documentElement,t=defaultSchema){this.logger=console,this.debug=!1,this.logDebugActivity=(e,t,r={})=>{this.debug&&this.logFormattedMessage(e,t,r)},this.element=e,this.schema=t,this.dispatcher=new Dispatcher(this),this.router=new Router(this)}static start(e,t){e=new Application(e,t);return e.start(),e}async start(){await domReady(),this.logDebugActivity("application","starting"),this.dispatcher.start(),this.router.start(),this.logDebugActivity("application","start")}stop(){this.logDebugActivity("application","stopping"),this.dispatcher.stop(),this.router.stop(),this.logDebugActivity("application","stop")}register(e,t){t.shouldLoad&&this.load({identifier:e,controllerConstructor:t})}load(e,...t){(Array.isArray(e)?e:[e,...t]).forEach(e=>this.router.loadDefinition(e))}unload(e,...t){(Array.isArray(e)?e:[e,...t]).forEach(e=>this.router.unloadIdentifier(e))}get controllers(){return this.router.contexts.map(e=>e.controller)}getControllerForElementAndIdentifier(e,t){e=this.router.getContextForElementAndIdentifier(e,t);return e?e.controller:null}handleError(e,t,r){this.logger.error(`%s

%o

%o`,t,e,r),null!=(r=window.onerror)&&r.call(window,t,"",0,0,e)}logFormattedMessage(e,t,r={}){r=Object.assign({application:this},r),this.logger.groupCollapsed(e+" #"+t),this.logger.log("details:",Object.assign({},r)),this.logger.groupEnd()}}function domReady(){return new Promise(e=>{"loading"==document.readyState?document.addEventListener("DOMContentLoaded",()=>e()):e()})}function ClassPropertiesBlessing(e){return readInheritableStaticArrayValues(e,"classes").reduce((e,t)=>Object.assign(e,propertiesForClassDefinition(t)),{})}function propertiesForClassDefinition(t){return{[t+"Class"]:{get(){var e=this["classes"];if(e.has(t))return e.get(t);throw e=e.getAttributeName(t),new Error(`Missing attribute "${e}"`)}},[t+"Classes"]:{get(){return this.classes.getAll(t)}},[`has${capitalize(t)}Class`]:{get(){return this.classes.has(t)}}}}function TargetPropertiesBlessing(e){return readInheritableStaticArrayValues(e,"targets").reduce((e,t)=>Object.assign(e,propertiesForTargetDefinition(t)),{})}function propertiesForTargetDefinition(t){return{[t+"Target"]:{get(){var e=this.targets.find(t);if(e)return e;throw new Error(`Missing target element "${t}" for "${this.identifier}" controller`)}},[t+"Targets"]:{get(){return this.targets.findAll(t)}},[`has${capitalize(t)}Target`]:{get(){return this.targets.has(t)}}}}function ValuePropertiesBlessing(e){const t=readInheritableStaticObjectPairs(e,"values");return t.reduce((e,t)=>Object.assign(e,propertiesForValueDefinitionPair(t)),{valueDescriptorMap:{get(){return t.reduce((e,t)=>{var t=parseValueDefinitionPair(t),r=this.data.getAttributeNameForKey(t.key);return Object.assign(e,{[r]:t})},{})}}})}function propertiesForValueDefinitionPair(e){const t=parseValueDefinitionPair(e),{key:r,name:s,reader:i,writer:n}=t;return{[s]:{get(){var e=this.data.get(r);return null!==e?i(e):t.defaultValue},set(e){void 0===e?this.data.delete(r):this.data.set(r,n(e))}},["has"+capitalize(s)]:{get(){return this.data.has(r)||t.hasCustomDefaultValue}}}}function parseValueDefinitionPair([e,t]){return valueDescriptorForTokenAndTypeDefinition(e,t)}function parseValueTypeConstant(e){switch(e){case Array:return"array";case Boolean:return"boolean";case Number:return"number";case Object:return"object";case String:return"string"}}function parseValueTypeDefault(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string"}return Array.isArray(e)?"array":"[object Object]"===Object.prototype.toString.call(e)?"object":void 0}function parseValueTypeObject(e){var t=parseValueTypeConstant(e.type);if(t){var r=parseValueTypeDefault(e.default);if(t!==r)throw new Error(`Type "${t}" must match the type of the default value. Given default value: "${e.default}" as "${r}"`);return t}}function parseValueTypeDefinition(e){var t=parseValueTypeObject(e),r=parseValueTypeDefault(e),s=parseValueTypeConstant(e),t=t||r||s;if(t)return t;throw new Error(`Unknown value type "${e}"`)}function defaultValueForDefinition(e){var t=parseValueTypeConstant(e);return t?defaultValuesByType[t]:void 0!==(t=e.default)?t:e}function valueDescriptorForTokenAndTypeDefinition(e,t){var e=dasherize(e)+"-value",r=parseValueTypeDefinition(t);return{type:r,key:e,name:camelize(e),get defaultValue(){return defaultValueForDefinition(t)},get hasCustomDefaultValue(){return void 0!==parseValueTypeDefault(t)},reader:readers[r],writer:writers[r]||writers.default}}const defaultValuesByType={get array(){return[]},boolean:!1,number:0,get object(){return{}},string:""},readers={array(e){e=JSON.parse(e);if(Array.isArray(e))return e;throw new TypeError("Expected array")},boolean(e){return!("0"==e||"false"==e)},number(e){return Number(e)},object(e){e=JSON.parse(e);if(null===e||"object"!=typeof e||Array.isArray(e))throw new TypeError("Expected object");return e},string(e){return e}},writers={default:writeString,array:writeJSON,object:writeJSON};function writeJSON(e){return JSON.stringify(e)}function writeString(e){return""+e}class Controller{constructor(e){this.context=e}static get shouldLoad(){return!0}get application(){return this.context.application}get scope(){return this.context.scope}get element(){return this.scope.element}get identifier(){return this.scope.identifier}get targets(){return this.scope.targets}get classes(){return this.scope.classes}get data(){return this.scope.data}initialize(){}connect(){}disconnect(){}dispatch(e,{target:t=this.element,detail:r={},prefix:s=this.identifier,bubbles:i=!0,cancelable:n=!0}={}){s=new CustomEvent(s?s+":"+e:e,{detail:r,bubbles:i,cancelable:n});return t.dispatchEvent(s),s}}Controller.blessings=[ClassPropertiesBlessing,TargetPropertiesBlessing,ValuePropertiesBlessing],Controller.targets=[],Controller.values={};export{Application,AttributeObserver,Context,Controller,ElementObserver,IndexedMultimap,Multimap,StringMapObserver,TokenListObserver,ValueListObserver,add,defaultSchema,del,fetch,prune};
